function  [D,Bt,Ct] = MinOnlineRDL2(D,signal,BETAs,B,C , IterMethod )
% This code is for online IRLS Dictionary Learning
% Data Sep 7 , 2011
% Coder Cewu Lu CUHK
% Input Dictionary : D  , two update matrix B ,C
% singal is observed vector , BETA is sparse coding result
% Output update result Dt, Bt, Ct

W = eye(size(BETAs,1));


%%%%  Parameter   %%%%%
tol = 1e-6;
MaxIter = 200;
%%%%%%%%%%%%%%%%%%%%%%%
 
 
    
 
  
 

Iter = 0; dif = 10^10;
W = eye(size(BETAs,1));
while tol < dif 
    DLast = D ;
    Iter = Iter + 1;
    if Iter == MaxIter
        break;
    end
    Bt = B;
    Ct = C;
    for ii = 1 : size(signal,1)
      %if Iter  ~= 1 
       W =  reweighted(signal(ii,:)',D(ii,:)', BETAs);
      %end
      Ct(ii).m =  Ct(ii).m  +  BETAs' * W * BETAs;
      Bt(ii).m =  Bt(ii).m  +  BETAs' * (W*signal(ii,:)');
      if 1 == IterMethod
       D(ii,:) = (inv(Ct(ii).m + (1e-8)*eye(size(Ct(ii).m)) )*Bt(ii).m)';
      else
       D(ii,:) =    NewtonMethod(Ct(ii).m,Bt(ii).m,D(ii,:)');
      end
    end
    
    dif = mean(abs(DLast(:) - D(:) ));
  
end
 
 
end
