function Dline = NewtonMethod(A,b,Init)
  
    Dline = Init;
    tol = 1e-2;
    MaxIter = 10;
    Iter = 0; dif = 10^10;
    while tol < dif 
      DLast = Dline ;
      Iter = Iter + 1;
      if Iter == MaxIter
         break;
       end
       d = A*Dline - b;
       a = -d'*A*d/(d'*A'*A*d);
       Dline =  Dline + a*(A*Dline - b);
       dif = mean(abs(DLast(:) - Dline(:) ));
    end
    Dline = Dline';
 

end
