function D = ORDL4BS_L1(signal, scale)

D0 = Dict_Init(size(signal,1), scale);
[B,C]  = MinInitOnlineRDL(D0 );
D = D0;
for ii = 1 : h : size(signal,2)
    BETA = sparseCoding_Batch(D, signal(:, ii:ii+h-1), 0.5);
    [D,B,C] = MinOnlineRDL2(D, signal(:, ii:ii+h-1), BETA', B, C,2 );
    fprintf('%d is done! \n',ii);
end

end
% 
% function D0 = Dict_Init(Dim, scale)
%    
%     D0 = rand(Dim, scale);
%     D0 = Dictionary_norm(D0);
% end
% 
% function D = Dictionary_norm(D)
%     for ii = 1 : size(D,2)
%         D(:,ii) = D(:,ii)/norm(D(:,ii), 2);
%     end
% end
% 
% 
% function  [B,C]  = MinInitOnlineRDL(D0 )
% 
% [row,col] = size(D0);
% C = [];
% B = [];
% for ii = 1 : row
%     C(ii).m = zeros(col);
%     B(ii).m = zeros(col,1);
% end
%  
% end
% 
% 
% function  beta = sparseCoding(D,x,lambad)
% [n,m] = size(D);
% I =  lambad * eye(m);
% A = [D;I];
% b = [x(:); zeros(m,1)];
% beta = L1Regression_Reweighted(A,b);
% end
% 
% 
% function [x,w] = L1Regression_Reweighted(A,b)
% [n,m] = size(A);
% indexX = (1 : n)';
% indexY = (1 : n)';
% val = ones(n,1);
% W = sparse(indexX,indexY,val);
% 
%  
% x = zeros(m,1);
% for jj = 1 : 100
%  Last = x;   
%  x = inv(A'*W*A + 10^(-9)*eye(m))*(A'*W*b);
%  w = 1./sqrt(abs(A*x - b).^2 +0.000001  );
%  for ii = 1 : n
%     W(ii,ii) = w(ii);
%  end
%  if norm(Last - x)/sqrt(norm(Last)*norm(x)) < 0.002
%      break;
%  end
% end
% 
% end
% 
% function  [D,Bt,Ct] = MinOnlineRDL2(D,signal,BETAs,B,C , IterMethod )
% % This code is for online IRLS Dictionary Learning
% % Data Sep 7 , 2011
% % Coder Cewu Lu CUHK
% % Input Dictionary : D  , two update matrix B ,C
% % singal is observed vector , BETA is sparse coding result
% % Output update result Dt, Bt, Ct
% 
% W = eye(size(BETAs,1));
% 
% 
% %%%%  Parameter   %%%%%
% tol = 1e-6;
% MaxIter = 200;
% %%%%%%%%%%%%%%%%%%%%%%%
%  
%  
%     
%  
%   
%  
% 
% Iter = 0; dif = 10^10;
% W = eye(size(BETAs,1));
% while tol < dif 
%     DLast = D ;
%     Iter = Iter + 1;
%     if Iter == MaxIter
%         break;
%     end
%     Bt = B;
%     Ct = C;
%     for ii = 1 : size(signal,1)
%       %if Iter  ~= 1 
%        W =  reweighted(signal(ii,:)',D(ii,:)', BETAs);
%       %end
%       Ct(ii).m =  Ct(ii).m  +  BETAs' * W * BETAs;
%       Bt(ii).m =  Bt(ii).m  +  BETAs' * (W*signal(ii,:)');
%       if 1 == IterMethod
%        D(ii,:) = (inv(Ct(ii).m + (1e-8)*eye(size(Ct(ii).m)) )*Bt(ii).m)';
%       else
%        D(ii,:) =    NewtonMethod(Ct(ii).m,Bt(ii).m,D(ii,:)');
%       end
%     end
%     
%     dif = mean(abs(DLast(:) - D(:) ));
%   
% end
%  
%  
% end
% 
% function Dline = NewtonMethod(A,b,Init)
%   
%     Dline = Init;
%     tol = 1e-2;
%     MaxIter = 10;
%     Iter = 0; dif = 10^10;
%     while tol < dif 
%       DLast = Dline ;
%       Iter = Iter + 1;
%       if Iter == MaxIter
%          break;
%        end
%        d = A*Dline - b;
%        a = -d'*A*d/(d'*A'*A*d);
%        Dline =  Dline + a*(A*Dline - b);
%        dif = mean(abs(DLast(:) - Dline(:) ));
%     end
%     Dline = Dline';
%  
% 
% end
% 
% 
% 
% function W =  reweighted(sLine,DLine, BETA)
%    deta = 0.0000001;
%    r = abs(sLine -  BETA*DLine );
%    W = eye(length(r));
%    for ii = 1 : length(r)
%        W(ii,ii) = 1/sqrt(abs(r(ii))^2 + deta);
%    end
% 
% end