function [x,w] = L1Regression_Reweighted(A,b)
[n,m] = size(A);
indexX = (1 : n)';
indexY = (1 : n)';
val = ones(n,1);
W = sparse(indexX,indexY,val);

 
x = zeros(m,1);
for jj = 1 : 100
 Last = x;   
 x = inv(A'*W*A + 10^(-9)*eye(m))*(A'*W*b);
 w = 1./sqrt(abs(A*x - b).^2 +0.000001  );
 for ii = 1 : n
    W(ii,ii) = w(ii);
 end
 if norm(Last - x)/sqrt(norm(Last)*norm(x)) < 0.002
     break;
 end
end

end