 function  D = BatchReweight(D,signal,BETAs )
% This code is for online IRLS Dictionary Learning
% Data Sep 7 , 2011
% Coder Cewu Lu CUHK
% Input Dictionary : D  , two update matrix B ,C
% singal is observed vector , BETA is sparse coding result
% Output update result Dt, Bt, Ct

W = eye(size(BETAs,1));


%%%%  Parameter   %%%%%
tol = 1e-4;
MaxIter = 200;
%%%%%%%%%%%%%%%%%%%%%%%

 

Iter = 0; dif = 10^10;
W = eye(size(BETAs,1));
while tol < dif 
    DLast = D ;
    Iter = Iter + 1;
    if Iter == MaxIter
        break;
    end
 
    for ii = 1 : size(signal,1)
      if Iter  ~= 1 
      W =  reweighted(signal(ii,:)',D(ii,:)', BETAs);
      end
%       size(BETAs)
%       size(W)
      SS = BETAs' * W * BETAs;
      D(ii,:) = (inv(SS + (1e-8)*eye(size(SS)))*(BETAs' * (W*signal(ii,:)')))'; 
    end
    
    dif = mean(abs(DLast(:) - D(:) ));
  
end
  
 
end


function W =  reweighted(sLine,DLine, BETA)
   deta = 0.000001;
   r = abs(sLine -  BETA*DLine );
   W = eye(length(r));
   for ii = 1 : length(r)
       W(ii,ii) = 1/sqrt(abs(r(ii))^2 + deta);
   end
   
end